package ru.daotech.agroinvest.adapters

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import kotlinx.android.synthetic.main.item_rating.view.*
import ru.daotech.agroinvest.R
import ru.daotech.agroinvest.autoNotify
import ru.daotech.agroinvest.models.Rating
import kotlin.properties.Delegates

class RatingAdapter : RecyclerView.Adapter<RatingAdapter.ViewHolderOther>() {

    var ratingList: List<Rating> by Delegates.observable(emptyList()) { _, old, new ->
        autoNotify(old, new) { o, n -> o.id == n.id }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderOther {
        val view = LayoutInflater.from(parent.context)
            .inflate(R.layout.item_rating, parent, false)
        return ViewHolderOther(view)
    }

    override fun getItemCount() = ratingList.size

    override fun onBindViewHolder(holder: ViewHolderOther, position: Int) {
        holder.bind(ratingList[position])
    }

    inner class ViewHolderOther(itemView: View) : RecyclerView.ViewHolder(itemView) {

        fun bind(itemRating: Rating) {
            itemView.rating_title.text = itemRating.name
            itemView.ratingBarIndicator.rating = itemRating.ratingInt.toFloat()
        }
    }
}
