package ru.daotech.agroinvest.container

import android.view.MenuItem
import io.reactivex.Observable
import ru.daotech.agroinvest.interfaces.MviView
import ru.daotech.agroinvest.models.InternetConnectivityState
import java.io.File

interface ContainerView : MviView<ContainerViewState> {

    fun toolbarVisibilityChanged(): Observable<Boolean>

    fun onLoginInit(): Observable<Unit>

    fun loadingIntent(): Observable<Unit>

    fun goToMyTasksIntent(): Observable<MenuItem>

    fun returnToMyTasksIntent(): Observable<Unit>

    fun goToTasksHistoryIntent(): Observable<MenuItem>

    fun goToCollectionHistoryIntent(): Observable<MenuItem>

    fun goToSectionsIntent(): Observable<MenuItem>

    fun goToAccidentReportIntent(): Observable<MenuItem>

    fun goToAboutPageIntent(): Observable<MenuItem>

    fun goToUpdateAppIntent(): Observable<MenuItem>

    fun goToRatingsIntent(): Observable<MenuItem>

    fun goToEarningsIntent(): Observable<MenuItem>

    fun goToSupportMessageIntent(): Observable<MenuItem>

    fun finishDayIntent(): Observable<MenuItem>

    fun onSignOutAcceptIntent(): Observable<Unit>

    fun onStableConnectionDataUploadIntent(): Observable<Unit>

    fun onDismissSnackbarIntent(): Observable<Unit>

    fun internetConnectionChanged(): Observable<Pair<Boolean, InternetConnectivityState>>

    fun screenshotSignalReceived(): Observable<File>

    fun onDismissSignOutResult(): Observable<Unit>

    fun onForcedLogoutIntent(): Observable<Unit>

    fun onSearchSubmitSubjectIntent(): Observable<String>

    fun exitApplicationIntent(): Observable<Unit>

    fun onListenUnreadMessageIntent(): Observable<Unit>

    fun onUploadBackupSignal(): Observable<List<File>?>
}