package ru.daotech.agroinvest.database

import androidx.room.Database
import androidx.room.RoomDatabase
import ru.daotech.agroinvest.database.dao.*
import ru.daotech.agroinvest.database.entities.*

@Database(
    entities = [
        TaskImpl::class,
        TaskPropertyImpl::class,
        TaskIntervalImpl::class,
        SectionImpl::class,
        CamundaImpl::class,
        ActionReportImpl::class,
        TrolleyInfoImpl::class,
        SupportMessageImpl::class,
        TaskMeasurementImpl::class,
        TaskPlantImpl::class,
        RecentUserImpl::class
    ],
    version = 25,
    exportSchema = false
)
abstract class AppDatabase : RoomDatabase() {
    abstract fun getTaskDao(): TaskDao

    abstract fun getTaskPropertyDao(): TaskPropertyDao

    abstract fun getTaskIntervalDao(): TaskIntervalDao

    abstract fun getSectionDao(): SectionDao

    abstract fun getCamundaDao(): CamundaDao

    abstract fun getActionReport(): ActionReportDao

    abstract fun getTrolleyInfo(): TrolleyInfoDao

    abstract fun getSupportMessageDao(): SupportMessageDao

    abstract fun getTaskMeasurementDao(): TaskMeasurementDao

    abstract fun getTaskPlantDao(): TaskPlantDao

    abstract fun getRecentUserDao(): RecentUserDao
}