package ru.daotech.agroinvest.database.dao

import androidx.room.Dao
import androidx.room.Query
import io.reactivex.Completable
import io.reactivex.Flowable
import ru.daotech.agroinvest.database.entities.SupportMessageImpl

@Dao
abstract class SupportMessageDao : BaseDao<SupportMessageImpl>() {

    @Query("SELECT COUNT(id) FROM support_message WHERE isRead = 0 AND :workerId = workerId")
    abstract fun getSupportMessageCount(workerId: String): Flowable<Int>

    @Query("SELECT * FROM support_message WHERE :workerId = workerId")
    abstract fun getAllSupportMessagesByWorkerId(workerId: String): Flowable<List<SupportMessageImpl>>

    @Query("DELETE FROM support_message ")
    abstract fun deleteAllMessages(): Completable
}