package ru.daotech.agroinvest.database.dao

import androidx.room.*
import io.reactivex.Completable
import io.reactivex.Observable
import ru.daotech.agroinvest.database.entities.TaskIntervalImpl

@Dao
abstract class TaskIntervalDao : BaseDao<TaskIntervalImpl>() {

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    abstract fun insertTaskInterval(taskIntervalImpl: TaskIntervalImpl): Completable

    @Query("UPDATE task_intervals SET startedAt = :startedAt, finishedAt = :finishedAt, taskId = :taskId WHERE id = :id")
    abstract fun updateTaskInterval(
        id: String,
        taskId: String,
        startedAt: String,
        finishedAt: String
    ): Completable

    @Delete
    abstract fun clearAllTaskIntervalData(taskIntervalImplList: List<TaskIntervalImpl>): Completable

    @Query("SELECT * FROM task_intervals")
    abstract fun getAllTaskIntervalData(): Observable<List<TaskIntervalImpl>>
}