package ru.daotech.agroinvest.database.dao

import androidx.room.Dao
import androidx.room.Delete
import androidx.room.Query
import io.reactivex.Completable
import io.reactivex.Observable
import ru.daotech.agroinvest.database.entities.TaskPropertyImpl

@Dao
abstract class TaskPropertyDao : BaseDao<TaskPropertyImpl>() {

    @Delete
    abstract fun clearAllTaskPropertyData(taskPropertyImplList: List<TaskPropertyImpl>) : Completable

    @Query("SELECT * FROM task_properties")
    abstract fun getAllTaskPropertyData(): Observable<List<TaskPropertyImpl>>
}