package ru.daotech.agroinvest.database.dao

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import io.reactivex.Completable
import io.reactivex.Observable
import ru.daotech.agroinvest.database.entities.TrolleyInfoImpl

@Dao
abstract class TrolleyInfoDao : BaseDao<TrolleyInfoImpl>() {

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    abstract fun insertTrolleyInfo(trolleyInfoImpl: TrolleyInfoImpl): Completable

    @Query("SELECT * FROM trolley WHERE id = :id")
    abstract fun getTrolleyInfoById(id: String): Observable<List<TrolleyInfoImpl>>

    @Query("SELECT * FROM trolley WHERE workerId = :workerId AND namespace = :namespace")
    abstract fun getFullTrolleyHistory(
        workerId: String,
        namespace: String
    ): Observable<List<TrolleyInfoImpl>>

    @Query("UPDATE trolley SET trolley = :trolley, registeredAt = :registeredAt, workerId = :workerId, type = :type WHERE id = :id")
    abstract fun updateTrolleyInfo(
        id: String,
        trolley: Int,
        registeredAt: String,
        workerId: String,
        type: String
    ): Completable
}