package ru.daotech.agroinvest.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey

interface RecentUser {
    val id: String
    val date: Long
    val workerName: String
    val personalNumber: String
}

@Entity(tableName = "recent_users")
data class RecentUserImpl(
        @PrimaryKey(autoGenerate = false)
        @ColumnInfo(name = "id") override val id: String,

        @ColumnInfo(name = "date") override val date: Long,

        @ColumnInfo(name = "workerName") override val workerName: String,

        @ColumnInfo(name = "personalNumber") override val personalNumber: String
) : RecentUser {
    constructor(workerId: String, workerName: String, personalNumber: String) : this(
            id = workerId,
            date = System.currentTimeMillis() / 1000,
            workerName = workerName,
            personalNumber = personalNumber
    )
}
