package ru.daotech.agroinvest.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey
import ru.daotech.agroinvest.service.jsonmodels.SectionPayloadLevel

interface Section {
    val id: String
    val namespace: String
    val level: Int
    val name: String
    val parentId: String?
}

@Entity(tableName = "sections")
data class SectionImpl(
    @PrimaryKey
    @ColumnInfo(name = "id") override val id: String,

    @ColumnInfo(name = "namespace") override val namespace: String,

    @ColumnInfo(name = "level") override val level: Int,

    @ColumnInfo(name = "name") override val name: String,

    @ColumnInfo(name = "parentId") override val parentId: String?
) : Section {
    constructor(from: SectionPayloadLevel, sessionId: String) : this(
        id = from.id,
        namespace = sessionId,
        parentId = from.parentId,
        level = from.level,
        name = from.name
    )
}
