package ru.daotech.agroinvest.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey

interface SupportMessage {
    val id: Long
    val workerId: String
    val message: String
    val time: String
    val isRead: Boolean
    val messageCode: Int
}

@Entity(tableName = "support_message")
data class SupportMessageImpl(
    @PrimaryKey(autoGenerate = true)
    @ColumnInfo(name = "id") override val id: Long = 0,

    @ColumnInfo(name = "workerId") override val workerId: String,

    @ColumnInfo(name = "message") override val message: String,

    @ColumnInfo(name = "time") override val time: String,

    @ColumnInfo(name = "isRead") override val isRead: Boolean,

    @ColumnInfo(name = "messageCode") override val messageCode: Int
) : SupportMessage {
    constructor(message: String, workerId: String, time: String, messageCode: Int) : this(
        message = message,
        workerId = workerId,
        time = time,
        isRead = false,
        messageCode = messageCode
    )
}