package ru.daotech.agroinvest.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.ForeignKey
import ru.daotech.agroinvest.service.jsonmodels.TaskIntervalPayload

interface TaskInterval {
    val id: String
    val taskId: String
    val startedAt: String
    val finishedAt: String
}

@Entity(
    tableName = "task_intervals",
    foreignKeys = [ForeignKey(
        entity = TaskImpl::class,
        parentColumns = ["id"],
        childColumns = ["taskId"],
        onDelete = ForeignKey.CASCADE
    )],
    primaryKeys = ["id", "taskId"]
)
data class TaskIntervalImpl(
    @ColumnInfo(name = "id") override val id: String,

    @ColumnInfo(name = "taskId") override val taskId: String,

    @ColumnInfo(name = "startedAt") override var startedAt: String,

    @ColumnInfo(name = "finishedAt") override var finishedAt: String
) : TaskInterval {

    constructor(from: TaskIntervalPayload, withTaskId: String) : this(
        id = from.id,
        taskId = withTaskId,
        startedAt = from.startedAt!!,
        finishedAt = from.finishedAt!!
    )
}