package ru.daotech.agroinvest.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.ForeignKey
import kotlinx.android.parcel.Parcelize
import ru.daotech.agroinvest.service.jsonmodels.PlantPayload

interface TaskPlant {
    val id: String
    val name: String
    val taskId: String
}

@Entity(
    tableName = "task_plant",
    foreignKeys = [ForeignKey(
        entity = TaskImpl::class,
        parentColumns = ["id"],
        childColumns = ["taskId"],
        onDelete = ForeignKey.CASCADE
    )],
    primaryKeys = ["id", "taskId"]
)
data class TaskPlantImpl(
    @ColumnInfo(name = "id") override val id: String,

    @ColumnInfo(name = "name") override val name: String,

    @ColumnInfo(name = "taskId") override val taskId: String
) : TaskPlant {

    constructor(from: PlantPayload, taskId: String) : this(
        id = from.plantId,
        name = from.name!!,
        taskId = taskId
    )
}