package ru.daotech.agroinvest.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey
import ru.daotech.agroinvest.service.jsonmodels.TrolleyInfoPayload
import java.util.*

interface TrolleyInfo {
    val id: String
    val trolley: Int
    val registeredAt: String
    val workerId: String
    val type: String
    val namespace: String
}

@Entity(tableName = "trolley")
data class TrolleyInfoImpl(
    @PrimaryKey
    @ColumnInfo(name = "id") override val id: String,

    @ColumnInfo(name = "trolley") override val trolley: Int,

    @ColumnInfo(name = "registeredAt") override var registeredAt: String,

    @ColumnInfo(name = "workerId") override var workerId: String,

    @ColumnInfo(name = "type") override var type: String,

    @ColumnInfo(name = "namespace") override var namespace: String

) : TrolleyInfo {

    constructor(from: TrolleyInfoPayload, namespace: String) : this(
        id = from.id,
        trolley = from.trolley,
        registeredAt = from.registeredAt,
        workerId = from.workerId,
        type = from.type,
        namespace = namespace
    )

    constructor(
        trolleyNumber: Int,
        registeredAt: String,
        workerId: String,
        type: String,
        namespace: String
    ) : this(
        id = UUID.randomUUID().toString(),
        trolley = trolleyNumber,
        registeredAt = registeredAt,
        workerId = workerId,
        type = type,
        namespace = namespace
    )
}