package ru.daotech.agroinvest.di

import android.content.Context
import dagger.BindsInstance
import dagger.Component
import ru.daotech.agroinvest.App
import ru.daotech.agroinvest.di.modules.AppModule
import ru.daotech.agroinvest.di.modules.DatabaseModule
import ru.daotech.agroinvest.di.modules.NetworkModule
import javax.inject.Singleton

@Singleton
@Component(modules = [
    AppModule::class,
    NetworkModule::class,
    DatabaseModule::class
])
interface AppComponent {

    @Component.Builder
    interface Builder {
        @BindsInstance
        fun context(context: Context): Builder

        fun network(networkModule: NetworkModule): Builder

        fun database(databaseModule: DatabaseModule): Builder

        fun build(): AppComponent
    }

    fun inject(app: App)
}