package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.fragments.pages.about.AboutPagePresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class AboutPageScope

@Module
class AboutPageModule {

    @AboutPageScope
    @Provides
    fun provideAboutPagePresenter(
        appStateManager: AppStateManager,
        repository: Repository
    ): AboutPagePresenter {
        return AboutPagePresenter(
            appStateManager = appStateManager,
            repository = repository
        )
    }
}