package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.AccidentReportCoordinator
import ru.daotech.agroinvest.fragments.pages.accident.AccidentReportPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class AccidentReportScope

@Module
class AccidentReportModule {

    @AccidentReportScope
    @Provides
    fun provideAccidentReportPresenter(
        appStateManager: AppStateManager,
        accidentReportCoordinator: AccidentReportCoordinator,
        repository: Repository
    ): AccidentReportPresenter {
        return AccidentReportPresenter(
            appStateManager = appStateManager,
            onAccidentReportFinished = accidentReportCoordinator::showNextScreen,
            repository = repository
        )
    }
}