package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.fragments.barcode_box.BarcodeBoxPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class BarcodeBoxScope

@Module
class BarcodeBoxModule {
    @BarcodeBoxScope
    @Provides
    fun provideBarcodeBoxPresenterPresenter(
        appStateManager: AppStateManager,
        repository: Repository
    ): BarcodeBoxPresenter {
        return BarcodeBoxPresenter(
            appStateManager = appStateManager,
            repository = repository
        )
    }
}