package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.coordinators.BarcodeScannerCoordinator
import ru.daotech.agroinvest.fragments.barcode.BarcodeScannerPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class BarcodeScannerScope

@Module
class BarcodeScannerModule {

    @BarcodeScannerScope
    @Provides
    fun provideBarcodeScannerPresenter(
        barcodeScannerCoordinator: BarcodeScannerCoordinator
    ): BarcodeScannerPresenter {
        return BarcodeScannerPresenter(onBarcodeRetrieved = barcodeScannerCoordinator::backToLoginScreen)
    }
}