package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.fragments.tasks.collectionHistory.CollectionHistoryPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class CollectionHistoryScope

@Module
class CollectionHistoryModule {
    @CollectionHistoryScope
    @Provides
    fun provideCollectionHistoryPresenter(
        repository: Repository,
        appStateManager: AppStateManager
    ): CollectionHistoryPresenter {
        return CollectionHistoryPresenter(
            repository,
            appStateManager
        )
    }
}