package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.SectionsCoordinator
import ru.daotech.agroinvest.fragments.sections.detailed.DetailedSectionPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class DetailedSectionScope

@Module
class DetailedSectionModule {
    @DetailedSectionScope
    @Provides
    fun provideDetailedSectionPresenter(
        sectionsCoordinator: SectionsCoordinator,
        repository: Repository
    ): DetailedSectionPresenter {
        return DetailedSectionPresenter(
            repository = repository,
            onItemClick = sectionsCoordinator::showSectionTasks
        )
    }
}