package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.TrolleyTiedCoordinator
import ru.daotech.agroinvest.fragments.detailed_task.detailed_task_in_progress.DetailedTaskProcessingPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class DetailedTaskProcessingScope

@Module
class DetailedTaskProcessingModule {
    @DetailedTaskProcessingScope
    @Provides
    fun provideDetailedTaskProcessingPresenter(
        repository: Repository,
        appStateManager: AppStateManager,
        trolleyTiedCoordinator: TrolleyTiedCoordinator
    ): DetailedTaskProcessingPresenter {
        return DetailedTaskProcessingPresenter(
            repository = repository,
            appStateManager = appStateManager,
            goToTrolleyTied = trolleyTiedCoordinator::showTrolleyTiedFromDetailed
        )
    }
}