package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.database.DatabaseRepository
import ru.daotech.agroinvest.fragments.earnings.EarningsPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class EarningsScope

@Module
class EarningsModule {
    @EarningsScope
    @Provides
    fun provideEarningsPresenter(
        repository: Repository,
        appStateManager: AppStateManager,
        databaseRepository: DatabaseRepository
    ): EarningsPresenter {
        return EarningsPresenter(
            repository = repository,
            appStateManager = appStateManager,
            databaseRepository = databaseRepository
        )
    }
}