package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.fragments.detailed_task.detailed_task_in_progress.header_field_container.HeaderFieldPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class HeaderFieldScope

@Module
class HeaderFieldModule {
    @HeaderFieldScope
    @Provides
    fun provideHeaderFieldPresenter(
        repository: Repository,
        appStateManager: AppStateManager
    ): HeaderFieldPresenter {
        return HeaderFieldPresenter(
            repository = repository,
            appStateManager = appStateManager
        )
    }
}