package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.LoginCoordinator
import ru.daotech.agroinvest.fragments.login.LoginPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class LoginScope

@Module
class LoginModule {

    @LoginScope
    @Provides
    fun provideLoginPresenter(
        repository: Repository,
        loginCoordinator: LoginCoordinator,
        appStateManager: AppStateManager
    ): LoginPresenter {
        return LoginPresenter(
            repository,
            onSuccessLogin = loginCoordinator::showWelcomeScreen,
            goToScan = loginCoordinator::showBarcodeScanner,
            appStateManager = appStateManager
        )
    }
}