package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.RatingsCoordinator
import ru.daotech.agroinvest.fragments.ratings.RatingsPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class RatingsScope

@Module
class RatingsModule {
    @RatingsScope
    @Provides
    fun provideRatingsPresenter(
        repository: Repository,
        sectionsCoordinator: RatingsCoordinator
    ): RatingsPresenter {
        return RatingsPresenter(
            repository,
            null //sectionsCoordinator::showDetailedSection
        )
    }
}