package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.TasksCoordinator
import ru.daotech.agroinvest.fragments.tasks.sectionTasks.SectionTasksPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class SectionTasksScope

@Module
class SectionTasksModule {
    @SectionTasksScope
    @Provides
    fun provideSectionTasksPresenter(
        repository: Repository,
        tasksCoordinator: TasksCoordinator
    ): SectionTasksPresenter {
        return SectionTasksPresenter(
            repository,
            tasksCoordinator::showDetailedTask
        )
    }
}