package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.SectionsCoordinator
import ru.daotech.agroinvest.fragments.sections.root.SectionsPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class SectionsScope

@Module
class SectionsModule {
    @SectionsScope
    @Provides
    fun provideSectionsPresenter(
        repository: Repository,
        sectionsCoordinator: SectionsCoordinator
    ): SectionsPresenter {
        return SectionsPresenter(
            repository,
            sectionsCoordinator::showDetailedSection
        )
    }
}