package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.coordinators.SplashCoordinator
import ru.daotech.agroinvest.fragments.splash.SplashPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class SplashScope

@Module
class SplashModule {

    @SplashScope
    @Provides
    fun provideSplashPresenter(
        appStateManager: AppStateManager,
        splashCoordinator: SplashCoordinator
    ): SplashPresenter {
        return SplashPresenter(
            appStateManager,
            onSplashFinished = splashCoordinator::showNextScreen
        )
    }
}