package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.RootCoordinator
import ru.daotech.agroinvest.fragments.support_notification.SupportNotificationPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class SupportNotificationScope

@Module
class SupportNotificationModule {

    @SupportNotificationScope
    @Provides
    fun supportNotificationPresenter(
        repository: Repository,
        appStateManager: AppStateManager,
        rootCoordinator: RootCoordinator
    ): SupportNotificationPresenter {
        return SupportNotificationPresenter(
            repository = repository,
            appStateManager = appStateManager,
            goToAccidentReport = rootCoordinator::goToAccidentReport
        )
    }
}