package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.TasksCoordinator
import ru.daotech.agroinvest.fragments.tasks.tasksHistory.TasksHistoryPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class TasksHistoryScope

@Module
class TasksHistoryModule {
    @TasksHistoryScope
    @Provides
    fun provideTasksHistoryPresenter(
        repository: Repository,
        tasksCoordinator: TasksCoordinator,
        appStateManager: AppStateManager
        ): TasksHistoryPresenter {
        return TasksHistoryPresenter(
            repository,
            tasksCoordinator::showDetailedTask,
            appStateManager
        )
    }
}