package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.RootCoordinator
import ru.daotech.agroinvest.coordinators.TasksCoordinator
import ru.daotech.agroinvest.coordinators.TrolleyTiedCoordinator
import ru.daotech.agroinvest.fragments.tasks.myTasks.TasksPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class TasksScope

@Module
class TasksModule {
    @TasksScope
    @Provides
    fun provideTasksPresenter(
        appStateManager: AppStateManager,
        repository: Repository,
        tasksCoordinator: TasksCoordinator,
        rootCoordinator: RootCoordinator,
        trolleyTiedCoordinator: TrolleyTiedCoordinator
    ): TasksPresenter {
        return TasksPresenter(
            appStateManager = appStateManager,
            repository = repository,
            onItemClick = tasksCoordinator::showDetailedTask,
            goToScannedTask = rootCoordinator::goToDetailedTask,
            goToTrolleyTied = trolleyTiedCoordinator::showTrolleyTiedScreen,
            goToBarcodeBox = rootCoordinator::goToBarcodeBox
        )
    }
}