package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.TrolleyTiedCoordinator
import ru.daotech.agroinvest.fragments.detailed_task.detailed_task_in_progress.timer_container.TimerContainerViewPresenter
import javax.inject.Scope


@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class TimerContainerScope

@Module
class TimerContainerModule {
    @TimerContainerScope
    @Provides
    fun provideTimerContainerPresenter(
        repository: Repository,
        appStateManager: AppStateManager,
        trolleyTiedCoordinator: TrolleyTiedCoordinator
    ): TimerContainerViewPresenter {
        return TimerContainerViewPresenter(
            repository = repository,
            appStateManager = appStateManager,
            goToTrolleyTied = trolleyTiedCoordinator::showTrolleyTiedFromDetailed
        )
    }
}