package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.fragments.trolley_tied.TrolleyTiedPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class TrolleyTiedScope

@Module
class TrolleyTiedModule {
    @TrolleyTiedScope
    @Provides
    fun provideTrolleyTiedPresenter(
        repository: Repository,
        appStateManager: AppStateManager
    ): TrolleyTiedPresenter {
        return TrolleyTiedPresenter(
            repository = repository,
            appStateManager = appStateManager
        )
    }
}