package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.RootCoordinator
import ru.daotech.agroinvest.fragments.pages.update.UpdateAppPresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class UpdateAppScope

@Module
class UpdateAppModule {

    @UpdateAppScope
    @Provides
    fun provideUpdateAppPresenter(
        rootCoordinator: RootCoordinator,
        repository: Repository,
        appStateManager: AppStateManager
    ): UpdateAppPresenter {
        return UpdateAppPresenter(
            goToMainScreen = rootCoordinator::goToMyTask,
            repository = repository,
            appStateManager = appStateManager
        )
    }
}