package ru.daotech.agroinvest.di.modules

import dagger.Module
import dagger.Provides
import ru.daotech.agroinvest.AppStateManager
import ru.daotech.agroinvest.business.Repository
import ru.daotech.agroinvest.coordinators.RootCoordinator
import ru.daotech.agroinvest.fragments.welcome.WelcomePresenter
import javax.inject.Scope

@Scope
@Retention(AnnotationRetention.RUNTIME)
annotation class WelcomeScope

@Module
class WelcomeModule {

    @WelcomeScope
    @Provides
    fun provideWelcomePresenter(
        appStateManager: AppStateManager,
        rootCoordinator: RootCoordinator,
        repository: Repository
    ): WelcomePresenter {
        return WelcomePresenter(
            appStateManager = appStateManager,
            goToMainScreen = rootCoordinator::goToMyTask,
            goToDetailedTask = rootCoordinator::runContainerWithDetailedTask,
            repository = repository
        )
    }
}