package ru.daotech.agroinvest.dialog.builder

import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.view.LayoutInflater
import android.widget.Button
import androidx.appcompat.app.AlertDialog
import io.reactivex.subjects.PublishSubject
import ru.daotech.agroinvest.R
import ru.daotech.agroinvest.dialog.DialogBuilderView

open class ContainerDialogBuilder : DialogBuilderView.ContainerDialogView {

    override fun buildFinishDayDialog(
        context: Context,
        onSignOutAccept: PublishSubject<Unit>
    ): AlertDialog {
        val factory = LayoutInflater.from(context)
        val finishDayDialogView = factory.inflate(R.layout.dialog_fragment_signout, null)
        val finishDayDialog: AlertDialog = AlertDialog.Builder(context).create()
        finishDayDialog.setView(finishDayDialogView)
        finishDayDialog.window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        finishDayDialogView.findViewById<Button>(R.id.cancel_signout_button)
            ?.setOnClickListener { finishDayDialog.dismiss() }
        finishDayDialogView.findViewById<Button>(R.id.confirm_signout_button)
            ?.setOnClickListener {
                finishDayDialog.dismiss()
                onSignOutAccept.onNext(Unit)
            }
        finishDayDialog.show()

        return  finishDayDialog
    }
}