package ru.daotech.agroinvest.dialog.builder

import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.net.Uri
import android.view.LayoutInflater
import android.widget.Button
import android.widget.TextView
import androidx.appcompat.app.AlertDialog
import com.jakewharton.rxbinding2.view.clicks
import io.reactivex.subjects.BehaviorSubject
import io.reactivex.subjects.PublishSubject
import ru.daotech.agroinvest.R
import ru.daotech.agroinvest.dialog.DialogBuilderView
import ru.daotech.agroinvest.service.jsonmodels.TaskPropertyPayload

open class GroupDialogBuilder : DialogBuilderView.GroupDialogView {

    override fun buildBottomSheetAttentionDialog(
        requestFocus: () -> Unit,
        showButtonProgressbar: () -> Unit,
        signalToFormSubmit: () -> Unit,
        retrieveSubject: BehaviorSubject<Pair<List<TaskPropertyPayload?>, List<Uri>>>?,
        context: Context
    ): AlertDialog {
        val factory = LayoutInflater.from(context)
        val taskAttentionDialogView = factory
            .inflate(R.layout.dialog_fragment_attention_cancel_task, null)
        val taskAttentionDialog = AlertDialog.Builder(context).create()
        taskAttentionDialog.setView(taskAttentionDialogView)
        taskAttentionDialog.window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        taskAttentionDialogView.findViewById<TextView>(R.id.dialog_title_view).text =
            context.getString(R.string.accident_group_dialog_title)
        taskAttentionDialogView.findViewById<Button>(R.id.task_cancel_cancel_attention_button)
            ?.setOnClickListener {
                taskAttentionDialog.dismiss()
            }
        taskAttentionDialogView.findViewById<Button>(R.id.task_cancel_confirm_attention_button)
            .clicks()
            .map {
                taskAttentionDialog.dismiss()
                requestFocus.invoke()
                showButtonProgressbar.invoke()
                signalToFormSubmit.invoke()
            }
            .subscribe()

        taskAttentionDialog.show()

        return taskAttentionDialog
    }
}