package ru.daotech.agroinvest.dialog.builder

import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.view.LayoutInflater
import android.view.View
import android.widget.LinearLayout
import android.widget.TextView
import androidx.appcompat.app.AlertDialog
import ru.daotech.agroinvest.R
import ru.daotech.agroinvest.dialog.DialogBuilderView

open class LoginDialogBuilder : DialogBuilderView.LoginDialogView {

    private lateinit var loginQueueDialog: AlertDialog
    private lateinit var loginQueueDialogView: View

    override fun buildLoginQueueDialog(
        context: Context,
        remoteMessageQueue: String?
    ) {

        if (::loginQueueDialogView.isInitialized) {
            loginQueueDialogView.findViewById<TextView>(R.id.dialog_signin_queue_message_view)?.text =
                remoteMessageQueue
            return
        }

        val factory = LayoutInflater.from(context)
        loginQueueDialogView = factory.inflate(R.layout.dialog_alert_signin_queue, null)
        loginQueueDialog = AlertDialog.Builder(context).create()
        loginQueueDialog.setView(loginQueueDialogView)
        loginQueueDialog.window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        remoteMessageQueue?.let {
            loginQueueDialogView.findViewById<TextView>(R.id.dialog_signin_queue_message_view)
                ?.setText(it)
        }
        loginQueueDialog.show()
    }

    override fun hideLoginQueueDialog() {
        if (::loginQueueDialog.isInitialized && loginQueueDialog.isShowing) {
            loginQueueDialog.hide()
        }
    }
}