package ru.daotech.agroinvest.dialog.builder

import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.view.LayoutInflater
import android.widget.Button
import android.widget.TextView
import androidx.appcompat.app.AlertDialog
import com.jakewharton.rxbinding2.view.clicks
import io.reactivex.subjects.PublishSubject
import ru.daotech.agroinvest.R
import ru.daotech.agroinvest.dialog.DialogBuilderView

open class TasksDialogBuilder: DialogBuilderView.TasksDialogView {

    override fun buildTaskAlreadyInProgressAttentionDialog(
        context: Context,
        dismissDialogSubject: PublishSubject<Unit>,
        goToDetailedTaskSubject: PublishSubject<String>,
        getCurrentRowNumber: () -> String
    ): AlertDialog {
        val factory = LayoutInflater.from(context)
        val taskAlreadyInProgressAttentionDialogView = factory
            .inflate(R.layout.dialog_fragment_task_already_inprogress, null)
        val taskAlreadyInProgressAttentionDialog = AlertDialog.Builder(context).create()
        taskAlreadyInProgressAttentionDialog.setView(taskAlreadyInProgressAttentionDialogView)
        taskAlreadyInProgressAttentionDialog.window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        taskAlreadyInProgressAttentionDialogView.findViewById<TextView>(R.id.current_raw_in_progress_view)
            .text = getCurrentRowNumber()
        taskAlreadyInProgressAttentionDialogView.findViewById<Button>(R.id.dismiss_dialog_already_inprogress_button)
            ?.setOnClickListener {
                taskAlreadyInProgressAttentionDialog.dismiss()
                dismissDialogSubject.onNext(Unit)
            }
        taskAlreadyInProgressAttentionDialogView.findViewById<Button>(R.id.go_to_detailed_task_button)
            .clicks()
            .map {
                taskAlreadyInProgressAttentionDialog.dismiss()
                goToDetailedTaskSubject.onNext(getCurrentRowNumber())
            }
            .subscribe()
        taskAlreadyInProgressAttentionDialog.show()

        return taskAlreadyInProgressAttentionDialog
    }
}