package ru.daotech.agroinvest.fragments.barcode_box

import ru.daotech.agroinvest.database.entities.TaskProperty

sealed class BarcodeBoxViewState {

    object EmptyState : BarcodeBoxViewState()

    object Loading : BarcodeBoxViewState()

    object SendSuccess : BarcodeBoxViewState()

    object SendFailed : BarcodeBoxViewState()

    object ClearError : BarcodeBoxViewState()

    object ShowErrorBarcodeScanGroupPropertyDialog : BarcodeBoxViewState()

    data class Error(val errorMessage: String) : BarcodeBoxViewState()

    data class ShowGroupPropertyForm(
        val currentTaskId: String,
        val scannedBarcodeValue: String,
        val groupCoincidence: TaskProperty
    ) : BarcodeBoxViewState()

    data class ShowChooseGroupPropertyDialog(
        val currentTaskId: String
    ) : BarcodeBoxViewState()
}