package ru.daotech.agroinvest.fragments.detailed_task

import android.net.Uri
import io.reactivex.Observable
import ru.daotech.agroinvest.interfaces.MviView
import ru.daotech.agroinvest.models.InternetConnectivityState
import ru.daotech.agroinvest.service.jsonmodels.TaskPropertyPayload

interface DetailedTaskView : MviView<DetailedTaskViewState> {
    fun loadingIntent(): Observable<String>

    fun startButtonClick(): Observable<String>

    fun taskCancelAcceptClick(): Observable<Unit>

    fun taskFinishAcceptClick(): Observable<Pair<String, String>>

    fun goToMyTasksIntent(): Observable<Unit>

    fun showAttentionCheck(): Observable<Unit>

    fun dismissTaskStates(): Observable<Unit>

    fun onErrorDismiss(): Observable<Unit>

    fun internetConnectivityStateIntent(): Observable<InternetConnectivityState>

    fun onCurrentTrolleyTiedIntent(): Observable<Unit>

    fun taskFinishWithPropsAcceptClick(): Observable<Triple<String, List<TaskPropertyPayload?>, List<Uri?>>>

    fun onSendGroupPropertyClick(): Observable<Pair<List<TaskPropertyPayload?>, List<Uri>>>

    fun onGoToBarcodeBoxFragmentIntent(): Observable<Unit>

    fun onDismissResponseDialogIntent(): Observable<Unit>

    fun snackbarDismiss(): Observable<Unit>
}