package ru.daotech.agroinvest.fragments.detailed_task.detailed_task_in_progress

sealed class DetailedTaskProcessingPartialViewState {
    abstract fun reduce(previousState: DetailedTaskProcessingViewState): DetailedTaskProcessingViewState

    object TaskStarted : DetailedTaskProcessingPartialViewState() {
        override fun reduce(previousState: DetailedTaskProcessingViewState): DetailedTaskProcessingViewState {
            return previousState.copy(
                isStarted = true
            )
        }
    }

    object TaskError : DetailedTaskProcessingPartialViewState() {
        override fun reduce(previousState: DetailedTaskProcessingViewState): DetailedTaskProcessingViewState {
            return previousState.copy(errorMessage = null)
        }
    }

    data class TaskErrorWithMessage(val errorMessage: String) :
        DetailedTaskProcessingPartialViewState() {
        override fun reduce(previousState: DetailedTaskProcessingViewState): DetailedTaskProcessingViewState {
            return previousState.copy(
                errorMessage = errorMessage
            )
        }
    }

    data class GoToTrolleyTied(val nfcTrolleyMark: String) :
        DetailedTaskProcessingPartialViewState() {
        override fun reduce(previousState: DetailedTaskProcessingViewState): DetailedTaskProcessingViewState {
            return previousState.copy(
                nfcTrolleyMark = nfcTrolleyMark
            )
        }
    }
}