package ru.daotech.agroinvest.fragments.detailed_task.detailed_task_in_progress.choose_group_container

import ru.daotech.agroinvest.database.entities.TaskPlant
import ru.daotech.agroinvest.database.entities.TaskProperty

sealed class ChooseGroupViewState {

    object Loading : ChooseGroupViewState()

    object Error : ChooseGroupViewState()

    object EmptyState : ChooseGroupViewState()

    object EmptyPlants : ChooseGroupViewState()

    data class ChoiceDoneState(val groupType: TaskProperty?) : ChooseGroupViewState()

    data class GroupTypeLoaded(
        val groupTypeList: List<TaskProperty>?,
        val plantList: List<TaskPlant>?
    ) : ChooseGroupViewState()
}