package ru.daotech.agroinvest.fragments.pages.accident

import ru.daotech.agroinvest.database.relation.TaskWithProperties
import ru.daotech.agroinvest.models.Worker

sealed class AccidentReportViewState {

    object Loading : AccidentReportViewState()

    object SendFailed : AccidentReportViewState()

    object SendContinuationState : AccidentReportViewState()

    object SendSuccess : AccidentReportViewState()

    object Error : AccidentReportViewState()

    data class ErrorWithMessage(val message: String) : AccidentReportViewState()

    data class Success(val isAuthenticated: Boolean) : AccidentReportViewState()

    data class TaskLoaded(
        val taskWithProperties: TaskWithProperties,
        val currentWorkerSimple: Worker?
    ) : AccidentReportViewState()
}