package ru.daotech.agroinvest.fragments.splash

import android.content.Context
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.hannesdorfmann.mosby3.mvi.MviFragment
import dagger.android.support.AndroidSupportInjection
import io.reactivex.Observable
import kotlinx.android.synthetic.main.fragment_splash.view.*
import ru.daotech.agroinvest.R
import ru.daotech.agroinvest.container.AppBarController
import javax.inject.Inject

class SplashFragment : MviFragment<SplashView, SplashPresenter>(), SplashView {

    @Inject
    lateinit var splashPresenter: SplashPresenter

    override fun onAttach(context: Context) {
        AndroidSupportInjection.inject(this)
        super.onAttach(context)
    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        val view = inflater.inflate(R.layout.fragment_splash, container, false)

        val quotes = setOf(
            R.string.quote_splash_1,
            R.string.quote_splash_2,
            R.string.quote_splash_3,
            R.string.quote_splash_4,
            R.string.quote_splash_5,
            R.string.quote_splash_6,
            R.string.quote_splash_7,
            R.string.quote_splash_8,
            R.string.quote_splash_9,
            R.string.quote_splash_10,
            R.string.quote_splash_11,
            R.string.quote_splash_12,
            R.string.quote_splash_13,
            R.string.quote_splash_14,
            R.string.quote_splash_15,
            R.string.quote_splash_16,
            R.string.quote_splash_17,
            R.string.quote_splash_18,
            R.string.quote_splash_19,
            R.string.quote_splash_20,
            R.string.quote_splash_21,
            R.string.quote_splash_22,
            R.string.quote_splash_23,
            R.string.quote_splash_24
        )

        view.quoteView.text = getString(quotes.random())

        return view
    }

    override fun render(state: SplashViewState) {
        (activity as? AppBarController)?.hideAppBar()
    }

    override fun loadingIntent(): Observable<Unit> = Observable.just(Unit)

    override fun createPresenter(): SplashPresenter {
        return splashPresenter
    }
}