package ru.daotech.agroinvest.fragments.support_notification

import ru.daotech.agroinvest.adapters.BaseMessageModelView
import ru.daotech.agroinvest.database.entities.SupportMessage

sealed class SupportNotificationViewState {

    object Loading : SupportNotificationViewState()

    object LoadingDismiss : SupportNotificationViewState()

    object Error : SupportNotificationViewState()

    object EmptyState : SupportNotificationViewState()

    object GoToAccidentState : SupportNotificationViewState()

    data class LoadedSupportMessages(val supportMessagesList: List<BaseMessageModelView>) :
        SupportNotificationViewState()
}