package ru.daotech.agroinvest.fragments.welcome

import ru.daotech.agroinvest.models.Worker

sealed class WelcomePartialViewState {
    abstract fun reduce(previousState: WelcomeViewState): WelcomeViewState

    data class ShowWorkerInfo(val worker: Worker) : WelcomePartialViewState() {
        override fun reduce(previousState: WelcomeViewState): WelcomeViewState {
            return previousState.copy(worker = worker, errorMessage = null)
        }
    }

    data class Error(val errorMessage: String) : WelcomePartialViewState() {
        override fun reduce(previousState: WelcomeViewState): WelcomeViewState {
            return previousState.copy(errorMessage = errorMessage)
        }
    }

    object ShowNextScreen : WelcomePartialViewState() {
        override fun reduce(previousState: WelcomeViewState): WelcomeViewState {
            return previousState
        }

    }

    object ClearError : WelcomePartialViewState() {
        override fun reduce(previousState: WelcomeViewState): WelcomeViewState {
            return previousState.copy(errorMessage = null)
        }

    }
}