package ru.daotech.agroinvest.network.models

import com.google.gson.Gson
import ru.daotech.agroinvest.models.RequestTypeEnum
import java.io.Serializable

class FileUploadRequest(
    override val type: BaseVariable<String> = BaseVariable(RequestTypeEnum.FILE_UPLOAD.requestType),
    override val meta: BaseVariable<String>,
    override val payload: BaseVariable<String>
) : Serializable, BaseRequest {

    data class PayloadRequest(
        val workerId: String
    ) : BasePayload() {
        override fun toString(): String {
            return Gson().toJson(this)
        }
    }

    data class MetaRequest(
        override val workerId: String?,
        override var deviceId: String?,
        override val sessionId: String,
        override var deviceTimeMark: String?,
        override var serverTimeMark: String?,
        override var deltaTimestamp: Int?
    ) : BaseMetaDeviceData() {
        override fun toString(): String {
            return Gson().toJson(this)
        }
    }
}

class FileUploadResponse(
    val status: Boolean,
    val message: String?,
    val data: List<FileUploadResponseData>
) : Serializable {

    data class FileUploadResponseData(
        val name: String,
        val mimetype: String,
        val size: Int?
    ) : Serializable
}