package ru.daotech.agroinvest.network.models

import com.google.gson.Gson
import java.io.Serializable

data class TrolleyRequest(
    override val type: BaseVariable<String>,
    override val meta: BaseVariable<String>,
    override val payload: BaseVariable<String>
) : Serializable, BaseRequest {

    data class PayloadRequest(
        val timestamp: String,
        val trolleyNumber: String
    ) : BasePayload() {
        override fun toString(): String {
            return Gson().toJson(this)
        }
    }

    data class MetaRequest(
        override val workerId: String?,
        override var deviceId: String?,
        override val sessionId: String,
        override var deviceTimeMark: String?,
        override var serverTimeMark: String?,
        override var deltaTimestamp: Int?
    ) : BaseMetaDeviceData() {
        override fun toString(): String {
            return Gson().toJson(this)
        }
    }
}