package ru.daotech.agroinvest.service.events

import ru.daotech.agroinvest.models.Worker
import ru.daotech.agroinvest.service.jsonmodels.WorkerPayload

data class WorkerInfo(val worker: Worker) : Event {
    constructor(workerPayload: WorkerPayload) : this(
        worker = Worker(
            id = workerPayload.id,
            name = workerPayload.name,
            personalNumber = workerPayload.code,
            department = workerPayload.department,
            positionName = workerPayload.position.name,
            positionId = workerPayload.positionId,
            departmentId = workerPayload.departmentId,
            exchangers = workerPayload.exchangers,
            ratings = workerPayload.ratings,
            earnings = workerPayload.earnings,
            nfcMode = workerPayload.nfcMode
        )
    )
}