package ru.daotech.agroinvest.service.jsonmodels

import com.beust.klaxon.TypeAdapter
import com.beust.klaxon.TypeFor
import kotlin.reflect.KClass

class QueueMessage(
    @TypeFor(field = "payload", adapter = PayloadTypeAdapter::class)
    val type: String,
    val payload: QueueMessagePayload?
)

class PayloadTypeAdapter : TypeAdapter<QueueMessagePayload> {
    override fun classFor(type: Any): KClass<out QueueMessagePayload> = when (type as String) {
        "signIn" -> WorkerPayload::class
        "workerInfo" -> WorkerPayload::class
        "signOutRemote" -> SignOutPayload::class
        "signOut" -> WorkerPayload::class
        "broadcastMessage" -> BroadcastMessagePayload::class
        "signMessage" -> SignInMessagePayload::class
        "taskInfo" -> TaskPayload::class
        "task" -> TaskPayload::class
        "taskStart" -> TaskStartPayload::class
        "taskCancel" -> TaskCancelPayload::class
        "taskFinish" -> TaskFinishPayload::class
        "serverData" -> ServerDataPayload::class
        "trolleyInfo" -> TrolleyInfoPayload::class
        "trolleyUnbind" -> TrolleyUnbindPayload::class
        "barcodeBox" -> BarcodeBoxMessagePayload::class
        "makeScreenshot" -> ScreenshotMessagePayload::class
        "supportMessage" -> SupportMessagePayload::class
        "uploadBackup" -> UploadBackupPayload::class
        else -> QueueMessagePayload::class
    }
}

open class QueueMessagePayload