package ru.daotech.agroinvest.service.jsonmodels

import com.beust.klaxon.Json

data class SectionPayload(
    val name: String,
    val structure: List<SectionPayloadLevel>
) {
    @Json(ignored = true)
    val fullName: String
        get() = structure
            .map { level -> level.name }
            .takeLast(2)
            .joinToString(separator = " -> ")
}

data class SectionPayloadLevel(
    val level: Int,
    val id: String,
    val name: String,
    val parentId: String? = null
)