package ru.daotech.agroinvest.service.jsonmodels

import android.os.Parcelable
import kotlinx.android.parcel.Parcelize
import ru.daotech.agroinvest.models.Department

data class TaskPayload(
    val id: String,
    val name: String,
    val isFinished: Boolean,
    val orderBy: Int,
    val color: String,
    val position: Position? = null,
    val department: Department? = null,
    val section: SectionPayload? = null,
    val description: String,
    val startAt: String,
    val finishAt: String,
    val startedAt: String? = null,
    val finishedAt: String? = null,
    val sectionId: String? = null,
    val workerId: String? = null,
    val workerName: String? = null,
    val parentId: String? = null,
    val rating: Float,
    val rowNumber: Int? = null,
    val inProgress: Boolean,
    val taskLimit: Int? = null, // minutes
    val properties: List<TaskPropertyPayload>,
    val intervals: List<TaskIntervalPayload>,
    val measurements: List<TaskMeasurementPayload>,
    val plants: List<PlantPayload>? = null,
    val isHarvesting: Boolean? = null
) : QueueMessagePayload()

@Parcelize
data class TaskPropertyPayload(
    var id: String,
    var name: String,
    var type: String,
    var stage: String,
    var value: String,
    var regexp: String,
    var parentId: String,
    var required: Boolean,
    var description: String,
    var timestamp: String? = "",
    var workerId: String? = ""
) : Parcelable

@Parcelize
data class TaskIntervalPayload(
    val id: String,
    val taskId: String,
    val startedAt: String? = "",
    val finishedAt: String? = ""
) : Parcelable

@Parcelize
data class TaskMeasurementPayload(
    val barcode: String? = "",
    val parentId: String? = "",
    val plantId: String? = "",
    val taskId: String? = ""
) : Parcelable

@Parcelize
data class PlantPayload(
    val plantId: String,
    val name: String? = ""
) : Parcelable
